import QtQuick 2.7
import QtQuick.Window 2.15
import QtQuick.Layouts 1.2
import QtGraphicalEffects 1.0
import QtQuick.Controls 2.5
import QtQuick.Templates 2.5 as T
import org.ukui.qqc2style.private 1.0 as StylePrivate


T.Menu {
    id: control
//    StylePrivate.APPParameter{
//        id: appP
//    }
//    palette: app.palette
//    font: app.font

    implicitWidth: Math.max(background ? background.implicitWidth : 0,
                            contentItem ? contentItem.implicitWidth + leftPadding + rightPadding : 0)
    implicitHeight: Math.max(background ? background.implicitHeight : 0,
                             contentItem ? contentItem.implicitHeight : 0) + topPadding + bottomPadding

    margins: 0

    property var scrollbarWidth: 0
//    leftPadding: menu.leftRightPadding
//    rightPadding: menu.leftRightPadding
//    topPadding: menu.topBottomPadding
//    bottomPadding: menu.topBottomPadding
    property var maxW: 0
    onVisibleChanged: {
//        console.log("DTK onvisible changed...", control.contentModel.count, visible, width, height, x, y, parent, parent.x, parent.y)
        if(visible && popHandle && parent)
        {
//         console.log("maptoglobale...", parent.mapToGlobal(x, y))
            popHandle.setPosion(parent.mapToGlobal(x, y).x, parent.mapToGlobal(x, y).y)
        }
        if(visible && popHandle && !popHandle.visible){
            popHandle.open()
        }
        else if(!visible && popHandle && popHandle.visible)
            popHandle.close()
    }

    onYChanged: {
//        console.log("menu y changedddd", y, control.contentModel.count)
        if(popHandle && parent)
        {
//         console.log("maptoglobale...", parent.mapToGlobal(x, y))
            popHandle.setPosion(parent.mapToGlobal(x, y).x, parent.mapToGlobal(x, y).y)
        }
    }

    onXChanged: {
        if(popHandle && parent)
        {
//         console.log("maptoglobale...", parent.mapToGlobal(x, y))
            popHandle.setPosion(parent.mapToGlobal(x, y).x, parent.mapToGlobal(x, y).y)
        }
    }
//    onCountChanged:
//    {
//        if(control1){
//            for(var i = 0; i < control1.contentModel.count; i++)
//            {
//                control1.removeItem(control1.itemAt(i));
//            }
//            for(var j = 0; j < control.contentModel.count; j++)
//            {
//                control1.addItem(control.itemAt(j));
//            }
//        }
//    }

    StylePrivate.UKUIMenu{
        id: menu
    }


    ParseInterface{
        id: parseInterface
    }

    function getStartColor(dtcolor)
    {
        return parseInterface.pStartColor(dtcolor)
    }
    function getEndColor(dtcolor)
    {
        return parseInterface.pEndColor(dtcolor)
    }
    StylePrivate.APPParameter{
        id: app
    }


    StylePrivate.PopupHandle{
        id: popHandle
        onVisibleChanged: {
//            console.log("popupHandle visible changedddd", visible, control.visible)
//            popupwindow.visible = visible
            if(control.visible !== visible){
                control.visible = visible
            }
        }
        delegate: Window {
            id: popupwindow

            width: control1 ? control1.width : 0
            height: control1 ? control1.height : 0
    //        blurControl: control
            flags: Qt.ToolTip

            Connections {
                target: popHandle
                function onVisibleChanged(visible) {
//                    console.log("connections pophandle visible changeddddd", visible)
                    if(visible)
                        popupwindow.show()
                    else
                        popupwindow.hide()
                }
                function onSizeChanged(width, height){
                    control1.contentItem.implicitWidth = width
                    control1.contentItem.implicitHeight = height
                }

            }

    //        rootWindow: control
    //        visible: control.visible
            //Component.onCompleted: console.log("popupwindow visible...", visible)
            onVisibleChanged: {
//                console.log("popupwindow onvisiblechanged 0000", visible, control1.visible, popHandle.isVisible(), control.contentModel, control1.contentModel)
                if(visible !== control1.visible)
                    control1.visible = visible
                //                if(visible && !control1.visible)
//                    control1.open()
//                else if(!visible && control1.visible)
//                    control1.close()
//                console.log("popupwindow onvisiblechanged 1111", visible, control1.visible, popHandle.isVisible(), control.contentModel, control1.contentModel)
            }
            Component.onCompleted: {
                for(var i = 0; i < control.contentModel.count; i++)
                {
                    control1.addItem(control.itemAt(i));
                }
            }

            T.Menu {
                id: control1

                visible: parent.visible

                palette: app.palette
                font: app.font

//                implicitWidth: Math.max(background ? background.implicitWidth : 0,
//                                        contentItem ? contentItem.implicitWidth + leftPadding + rightPadding : 0)
                 //Math.max(background ? background.implicitHeight : 0,
                                //         contentItem ? contentItem.implicitHeight : 0) + topPadding + bottomPadding

                margins: 0

                leftPadding: menu.leftRightPadding
                rightPadding: menu.leftRightPadding
                topPadding: menu.topBottomPadding
                bottomPadding: menu.topBottomPadding
                contentData: control.contentData
                onVisibleChanged: {
//                    console.log("window menu visible 000", visible, parent, parent.visible, popupwindow, popupwindow.visible, contentItem.visible, implicitWidth, implicitHeight)

                    if(visible === false && visible !== popHandle.visible)
                        popHandle.close();
//                    console.log("window menu visible 111", visible, parent, parent.visible, popupwindow, popupwindow.visible, contentItem.visible, implicitWidth, implicitHeight)
//                    console.log("window menu onVisibleChanged", control1.contentModel.count, width, height, implicitWidth, implicitHeight)

                    popHandle.setSize(implicitWidth, implicitHeight)

                }
                onImplicitWidthChanged: {
//                    console.log("window menu onwidthchangedddd", control1.contentModel.count, width, height, implicitWidth, implicitHeight)

                    popHandle.setSize(implicitWidth, implicitHeight)
                }
                onImplicitHeightChanged: {
//                    console.log("window menu onheightchangeddddd", control1.contentModel.count, width, height, implicitWidth, implicitHeight)
                    popHandle.setSize(implicitWidth, implicitHeight)
                }
                Component.onCompleted: {

//                    console.log("window menu component size", control1.contentModel.count, width, height, implicitWidth, implicitHeight)
                    popHandle.setSize(implicitWidth, implicitHeight)
                }
                Connections {
                    target: control
                    function onCountChanged(count) {
                        if(control1 != null){
                            for(var i = 0; i < control1.contentModel.count; i++)
                            {
                                control1.removeItem(control1.itemAt(i));
                            }
                            for(var j = 0; j < control.contentModel.count; j++)
                            {
                                control1.addItem(control.itemAt(j));
                            }
                        }
                    }

                }

                delegate: MenuItem {
                    id: menuitem
//                    width: listview.width - scrollbarWidth
                    Component.onCompleted: {
//                        console.log("delegate menuitem......")
                        if(menuitem.hasOwnProperty("itemHasChecked")){
                            itemHasChecked = true
                        }
                    }

                }
                contentItem: ListView {
                    id: listview
                    implicitHeight: contentHeight
                    model: control1.contentModel
                    visible: parent.visible
                    onImplicitHeightChanged: control1.implicitHeight = listview.implicitHeight + control1.topPadding + control1.bottomPadding


//                    implicitWidth: contentWidth
                    /*{
                        var maxWidth = 0;
                        for (var l in control1.contentItem.contentItem.children) {
                            if(!(control1.contentItem.contentItem.children[l] instanceof MenuSeparator))
                            maxWidth = Math.max(maxWidth, control1.contentItem.contentItem.children[l].implicitWidth)
                        }

                       if(maxW === 0)
                        maxW = maxWidth

            //            control1.implicitWidth = Math.max(background ? background.implicitWidth : 0,
            //                                            contentItem ? maxW + control1.leftPadding + control1.rightPadding : 0)

                        return maxWidth;
                    }*/

                    //todo   why ApplicationWindow.window is null
                    currentIndex: control1.currentIndex || 0
                    keyNavigationEnabled: true
                    keyNavigationWraps: true
                    ScrollBar.vertical: ScrollBar {//会与menuitem重叠  所以宽度设为0  单独使背景里的scrollbar，在position改变时  listview滚动到下面的时候有点奇怪
                        id: vscrollbar
                        active: visible
                        visible: popHandle ? popHandle.outScreen : false
                        width: 0
                    }

                    property bool hasCheckables: false
                    property bool hasIcons: false
//                    onContentYChanged: {
//                        if (!scrollbar.active) {
//                            if(scrollbar.visible){
//                                if(contentY/(contentHeight - height) >= 1.0)
//                                    scrollbar.position = 1.0
//                                else if(contentY/(contentHeight - height) <= 0.0)
//                                    scrollbar.position = 0.0
//                                else
//                                    scrollbar.position = contentY/(contentHeight - height)
//                            }
//                        }
//                    }

//                    onContentHeightChanged: {
//                        scrollbar.size = Math.min(height / contentHeight, 1);
//                    }


                    Connections{
                        target: popHandle
                        function onOutScreenChanged()
                        {
//                            console.log("onOutScreenChanged....", popHandle.outScreen)
                            listview.interactive = popHandle.outScreen ? true : false;
                            listview.clip = listview.interactive;
                            scrollbar.visible = listview.interactive;
                        }
                    }
                }

                Connections {
                    target: control1.contentItem.contentItem
                    function onChildrenChanged() {
                        var checkable = false;
                        var needIcon = false;
                        for (var i in control1.contentItem.contentItem.children) {
                            var child = control1.contentItem.contentItem.children[i];
                            if (child.checkable) {
                                control1.contentItem.hasCheckables = true;
                                checkable = true;
                            }
                            if (child.icon && child.icon.hasOwnProperty("name") && (child.icon.name.length > 0 || child.icon.source.toString().length > 0)) {
                                control1.contentItem.hasIcons = true;
                                needIcon = true;
                            }
                        }
                        if(checkable){
                            for (var k in control1.contentItem.contentItem.children) {
                                var childk = control1.contentItem.contentItem.children[k];
                                if(childk.hasOwnProperty("itemLeftSpace")){
                                    childk.itemLeftSpace = 20 + childk.leftPadding;
                                }
                            }
                        }
                        if(needIcon){
                            for (var j in control1.contentItem.contentItem.children) {
                                var childj = control1.contentItem.contentItem.children[j];
                                var b = childj.icon && childj.icon.hasOwnProperty("name") && (childj.icon.name.length > 0 || childj.icon.source.toString().length > 0);
                                if(childj.hasOwnProperty("labelLeftSpace"))
                                    childj.labelLeftSpace = b ? 4 : 20;
                            }
                        }
                        var maxWidth = 0;
                        for (var l in control1.contentItem.contentItem.children) {
                            if(!(control1.contentItem.contentItem.children[l] instanceof MenuSeparator))
                            maxWidth = Math.max(maxWidth, control1.contentItem.contentItem.children[l].implicitWidth)
                        }
                        for (var m in control1.contentItem.contentItem.children) {
                            control1.contentItem.contentItem.children[m].implicitWidth = maxWidth;
                        }


                       if(maxW === 0)
                        maxW = maxWidth

                       listview.implicitWidth = maxWidth;
                       control1.implicitWidth = listview.implicitWidth  + scrollbarWidth + control1.leftPadding + control1.rightPadding
            //            control1.implicitWidth = Math.max(background ? background.implicitWidth : 0,
            //                                            contentItem ? maxW + control1.leftPadding + control1.rightPadding : 0)

                    }
                }

                background: Rectangle {
                    id: backRec
                    anchors.fill: parent
                    radius: menu.radius

                    color: gradientRec.visible ? "transparent" : getStartColor(menu.normalBC)
                    opacity: menu.bcColorAlpha
                    border.color: getStartColor(menu.normalBorderColor)
                    border.width: menu.border
            //        layer.enabled: true
//                    Component.onCompleted: console.log("menu back opacity...", opacity, menu.bcColorAlpha)
                    ScrollBar {
                        id: scrollbar
                        active: visible
                        orientation: Qt.Vertical
                        visible: false
                        anchors.top: parent.top
                        anchors.topMargin: control1.topPadding
                        anchors.right: parent.right
                        height: listview.height
                        position: listview.visibleArea.yPosition
                        size: listview.visibleArea.heightRatio

                        onPositionChanged: {
                            if (active && listview.visibleArea.yPosition != position) {
                                vscrollbar.position = position;
                            }
                        }
                        onVisibleChanged:{
                            scrollbarWidth = scrollbar.width
                        }
                    }
                    Rectangle{
                        id: gradientRec
                        anchors.fill: parent
                        radius: parent.radius
                        border.width: parent.border.width
                        border.color: parent.border.color
                        opacity: menu.bcColorAlpha
                        gradient:  Gradient {
                            id:gradient
                            GradientStop { position: 0.0; color: getStartColor(menu.normalBC) }

                            GradientStop { position: 1.0; color: getEndColor(menu.normalBC)}
                        }
                        visible: !parseInterface.isSolidPattern(menu.normalBC)
                    }


                }
            }
        }
    }

    delegate: MenuItem {
    }
//    contentItem: ListView {
//        implicitHeight: contentHeight
//        property bool hasCheckables: false
//        property bool hasIcons: false
//        model: control.contentModel
//    }
}
