
import QtQuick 2.6
import QtQuick.Templates 2.5 as T
import org.ukui.qqc2style.private 1.0 as StylePrivate


T.RoundButton {
    id: controlRoot
    implicitWidth: {
    var contentwidth = implicitContentWidth + leftPadding + rightPadding
        return Math.max(implicitBackgroundWidth + leftInset + rightInset,
                        contentwidth)
    }
    implicitHeight: Math.max(implicitBackgroundHeight + topInset + bottomInset,
                             implicitContentHeight + topPadding + bottomPadding)

    leftPadding: StylePrivate.UKUIButton.margin
    rightPadding: StylePrivate.UKUIButton.margin

    hoverEnabled: true //Qt.styleHints.useHoverEffects TODO: how to make this work in 5.7?


    font: StylePrivate.APPParameter.font

    NormalControlColor{
    id:ncColor
    }

    contentItem: ButtonIconLabelContent {
        controlRoot: controlRoot
        anchors.centerIn: controlRoot
//        onWidthChanged: console.log(controlRoot.text, width)
    }
    background: BackGroundRectangle{
        controlRoot: controlRoot
        _radius: controlRoot.height/2
        anchors.fill: parent

    }
}
