import QtQuick 2.12
import QtQuick.Templates 2.12 as T
import org.ukui.qqc2style.private 1.0 as StylePrivate

T.TabBar {
    id: control

    implicitWidth: Math.max(implicitBackgroundWidth + leftInset + rightInset,
                            contentWidth + leftPadding + rightPadding)
    implicitHeight: Math.max(implicitBackgroundHeight + topInset + bottomInset,
                             contentHeight + topPadding + bottomPadding)

    spacing: 1
    ParseInterface{
        id: parseInterface
    }

    function getStartColor(dtcolor)
    {
        return parseInterface.pStartColor(dtcolor)
    }
    function getEndColor(dtcolor)
    {
        return parseInterface.pEndColor(dtcolor)
    }
    contentItem: ListView {        
        model: control.contentModel
        currentIndex: control.currentIndex

        spacing: control.spacing
        orientation: ListView.Horizontal
        boundsBehavior: Flickable.StopAtBounds
        flickableDirection: Flickable.AutoFlickIfNeeded
        snapMode: ListView.SnapToItem

//        highlightMoveDuration: 0
//        highlightRangeMode: ListView.ApplyRange
//        preferredHighlightBegin: 40
//        preferredHighlightEnd: width - 40
    }

    background: Rectangle {
        id: back
        implicitHeight: contentHeight
        implicitWidth: contentWidth
        //anchors.fill: control
        color: gradientRec.visible ? "transparent" : getStartColor(tabbar.normalColor)
        Rectangle{
            id: gradientRec
            anchors.fill: parent
            radius: parent.radius
            border.width: parent.border.width
            border.color: parent.border.color
            gradient:  Gradient {
                GradientStop { position: 0.0; color: getStartColor(tabbar.normalColor)}

                GradientStop { position: 1.0; color: getEndColor(tabbar.normalColor)}
            }
            visible: !parseInterface.isSolidPattern(tabbar.normalColor)
        }
    }

    StylePrivate.UKUITabBar{
        id: tabbar
    }

    StylePrivate.APPParameter{
        id: app
    }
}
